Bug 519519 - [RHEL5 gcc-c++] Code with virtual inheritance compiled by g++ crash at run-time
Summary: [RHEL5 gcc-c++] Code with virtual inheritance compiled by g++ crash at run-time
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: gcc
Version: 5.4
Hardware: All
OS: Linux
high
high
Target Milestone: rc
: ---
Assignee: Jakub Jelinek
QA Contact: BaseOS QE
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-08-26 22:10 UTC by Jeff Bastian
Modified: 2010-03-30 08:21 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of: 519517
Environment:
Last Closed: 2010-03-30 08:21:24 UTC
Target Upstream Version:


Attachments (Terms of Use)
reproducer program (1.67 KB, text/plain)
2009-08-26 22:17 UTC, Jeff Bastian
no flags Details
backported patch (2.81 KB, patch)
2009-08-26 22:41 UTC, Jeff Bastian
no flags Details | Diff


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2010:0232 0 normal SHIPPED_LIVE gcc bug fix update 2010-03-29 13:43:19 UTC

Description Jeff Bastian 2009-08-26 22:10:14 UTC
+++ This bug was initially created as a clone of Bug #519517 +++

Description of problem:
The attached program when compiled by g++ will crash at runtime.  It runs fine when compiled with Sun Studio CC and AIX xlC on their respective platforms.  This was reported upstream and a patch has been accepted.
  http://gcc.gnu.org/ml/gcc-patches/2009-07/msg00302.html
  http://gcc.gnu.org/viewcvs?revision=149297&view=revision

Please include this patch in the gcc-c++ compilers for RHEL 5.

Version-Release number of selected component (if applicable):
gcc-c++-4.1.2-46.el5

How reproducible:
every time

Steps to Reproduce:
1. g++ dyncast-segfault.cpp
2. ./a.out
  
Actual results:
...
in synchro_slave_base dtor
in my_object dtor
before DCASTing to my_module*
Segmentation fault

Expected results:
no seg fault

Additional info:

Comment 1 Jeff Bastian 2009-08-26 22:17:35 UTC
Created attachment 358782 [details]
reproducer program

Comment 2 Jeff Bastian 2009-08-26 22:41:37 UTC
Created attachment 358784 [details]
backported patch

This is a version of the upstream patch backported by Heath Petty for  gcc-c++-4.1.2

Comment 11 errata-xmlrpc 2010-03-30 08:21:24 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2010-0232.html


Note You need to log in before you can comment on or make changes to this bug.